Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.huihoo.jfox.jmx
Class MBeanServerSupport

    java.lang.Object
      |
      +--org.huihoo.jfox.jmx.MBeanServerSupport

All Implemented Interfaces:
  ExtendedMBeanServer, MBeanServer, MBeanServerConnection

public class MBeanServerSupport
extends java.lang.Object
implements ExtendedMBeanServer

Author:
  Young Yang

Constructor Summary
`MBeanServerSupport(java.lang.String domain)`
`MBeanServerSupport(java.lang.String domain, MBeanServer outer, MBeanServerDelegate delegate)`

Method Summary
`void` | `addNotificationListener(ObjectName objectName, NotificationListener listener, NotificationFilter filter, java.lang.Object handback)` Enables to add a listener to a registered MBean.
`void` | `addNotificationListener(ObjectName objectName, ObjectName listenerName, NotificationFilter filter, java.lang.Object handback)` Enables to add a listener to a registered MBean.
`ObjectInstance` | `createMBean(java.lang.String className, ObjectName objectName)` Instantiates and registers an MBean in the MBean server.
`ObjectInstance` | `createMBean(java.lang.String className, ObjectName objectName, java.lang.Object[] params, java.lang.String[] signatures)` Instantiates and registers an MBean in the MBean server.
`ObjectInstance` | `createMBean(java.lang.String className, ObjectName objectName, ObjectName loaderName)` Instantiates and registers an MBean in the MBean server.
`ObjectInstance` | `createMBean(java.lang.String className, ObjectName objectName, ObjectName loaderName, java.lang.Object[] params, java.lang.String[] signatures)` Instantiates and registers an MBean in the MBean server.
`java.lang.Object` | `getAttribute(ObjectName objectName, java.lang.String attribute)` Gets the value of a specific attribute of a named MBean.
`AttributeList` | `getAttributes(ObjectName objectName, java.lang.String[] attributes)` Enables the values of several attributes of a named MBean.
`java.lang.ClassLoader` | `getClassLoader(ObjectName loaderName)` Return the named `ClassLoader`.
`java.lang.ClassLoader` | `getClassLoaderFor(ObjectName objectName)` Return the `ClassLoader` that was used for loading the class of the named MBean.
`ClassLoaderRepository` | `getClassLoaderRepository()` Return the ClassLoaderRepository for this MBeanServer.
`java.lang.String` | `getDefaultDomain()` Returns the default domain used for naming the MBean.
`java.lang.String[]` | `getDomains()` Returns the list of domains in which any MBean is currently registered.
`java.lang.Integer` | `getMBeanCount()` Returns the number of MBeans registered in the MBean server.
`MBeanInfo` | `getMBeanInfo(ObjectName objectName)` This method discovers the attributes and operations that an MBean exposes for management.
`ObjectInstance` | `getObjectInstance(ObjectName objectName)` Gets the `ObjectInstance` for a given MBean registered with the MBean server.
`java.lang.Object` | `instantiate(java.lang.String className)` Instantiates an object using the list of all class loaders registered The MBean server will use the javax.management.MBeanServerFactory.getClassLoaderRepository(MBeanServer server) Default Loader Repository The object's class should have a public constructor.
`java.lang.Object` | `instantiate(java.lang.String className, java.lang.Object[] params, java.lang.String[] signatures)` Instantiates an object using the list of all class loaders registered The MBean server will use the javax.management.MBeanServerFactory.getClassLoaderRepository(MBeanServer server) Default Loader Repository The object's class should have a public constructor.
`java.lang.Object` | `instantiate(java.lang.String className, ObjectName loaderName)` Instantiates an object using the class Loader specified by its `ObjectName`.
`java.lang.Object` | `instantiate(java.lang.String className, ObjectName loaderName, java.lang.Object[] params, java.lang.String[] signatures)` Instantiates an object.
`java.lang.Object` | `invoke(ObjectName objectName, java.lang.String operationName, java.lang.Object[] params, java.lang.String[] signatures)` Invokes an operation on an MBean.
`boolean` | `isInstanceOf(ObjectName objectName, java.lang.String className)` Returns true if the MBean specified is an instance of the specified class, false otherwise.
`boolean` | `isRegistered(ObjectName objectName)` Checks whether an MBean, identified by its object name, is already registered with the MBean server.
`java.util.Set` | `queryMBeans(ObjectName objectName, QueryExp query)` Gets MBeans controlled by the MBean server.
`java.util.Set` | `queryNames(ObjectName objectName, QueryExp query)` Gets the names of MBeans controlled by the MBean server.
`void` | `registerInterceptor(MBeanServerInterceptorListener interceptor, MBeanServerNotificationFilter filter, java.lang.Object handback)` This function is JFoxMX private extension
`ObjectInstance` | `registerMBean(java.lang.Object obj, ObjectName objectName)` Registers a pre-existing object as an MBean with the MBean server.
`void` | `removeNotificationListener(ObjectName objectName, NotificationListener listener)` Enables to remove a listener from a registered MBean.
`void` | `removeNotificationListener(ObjectName objectName, NotificationListener listener, NotificationFilter filter, java.lang.Object handback)` Removes a listener from a registered MBean. The MBean must have a listener that exactly matches the given `listener`, `filter`, and `handback` parameters.
`void` | `removeNotificationListener(ObjectName objectName, ObjectName listenerName)` Enables to remove a listener from a registered MBean.
`void` | `removeNotificationListener(ObjectName objectName, ObjectName listenerName, NotificationFilter filter, java.lang.Object handback)` Removes a listener from a registered MBean. The MBean must have a listener that exactly matches the given `listener`, `filter`, and `handback` parameters.
`void` | `setAttribute(ObjectName objectName, Attribute attribute)` Sets the value of a specific attribute of a named MBean.
`AttributeList` | `setAttributes(ObjectName objectName, AttributeList attributes)` Sets the values of several attributes of a named MBean.
`void` | `unregisterInterceptor(MBeanServerInterceptorListener interceptor)`
`void` | `unregisterMBean(ObjectName objectName)` De-registers an MBean from the MBean server.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### MBeanServerSupport

    public MBeanServerSupport(java.lang.String domain)

### MBeanServerSupport

    public MBeanServerSupport(java.lang.String domain,
                              MBeanServer outer,
                              MBeanServerDelegate delegate)

Method Detail

### instantiate

    public java.lang.Object instantiate(java.lang.String className)
                                 throws ReflectionException,
                                        MBeanException

  Description copied from interface: `MBeanServer`
  Instantiates an object using the list of all class loaders registered The MBean server will use the javax.management.MBeanServerFactory.getClassLoaderRepository(MBeanServer server) Default Loader Repository The object's class should have a public constructor. It returns a reference to the newly created object. The newly created object is not registered in the MBean server.
  Specified by:
    `instantiate` in interface `MBeanServer`
  Following copied from interface: `javax.management.MBeanServer`
  Parameters:
    `className` - The class name of the object to be instantiated.
  Returns:
    The newly instantiated object.
  Throws:
    `ReflectionException` - Wraps a `java.lang.ClassNotFoundException` or the `java.lang.Exception` that occurred when trying to invoke the object's constructor.
    `MBeanException` - The constructor of the object has thrown an exception
    `RuntimeOperationsException` - Wraps a `java.lang.IllegalArgumentException`: The className passed in parameter is null.

### instantiate

    public java.lang.Object instantiate(java.lang.String className,
                                        ObjectName loaderName)
                                 throws ReflectionException,
                                        MBeanException,
                                        InstanceNotFoundException

  Description copied from interface: `MBeanServer`
  Instantiates an object using the class Loader specified by its `ObjectName`. If the loader name is null, the ClassLoader that loaded the MBean Server will be used. The object's class should have a public constructor. It returns a reference to the newly created object. The newly created object is not registered in the MBean server.
  Specified by:
    `instantiate` in interface `MBeanServer`
  Following copied from interface: `javax.management.MBeanServer`
  Parameters:
    `className` - The class name of the MBean to be instantiated.
    `loaderName` - The object name of the class loader to be used.
  Returns:
    The newly instantiated object.
  Throws:
    `ReflectionException` - Wraps a `java.lang.ClassNotFoundException` or the `java.lang.Exception` that occurred when trying to invoke the object's constructor.
    `MBeanException` - The constructor of the object has thrown an exception.
    `InstanceNotFoundException` - The specified class loader is not registered in the MBaenServer.
    `RuntimeOperationsException` - Wraps a `java.lang.IllegalArgumentException`: The className passed in parameter is null.

### instantiate

    public java.lang.Object instantiate(java.lang.String className,
                                        java.lang.Object[] params,
                                        java.lang.String[] signatures)
                                 throws ReflectionException,
                                        MBeanException

  Description copied from interface: `MBeanServer`
  Instantiates an object using the list of all class loaders registered The MBean server will use the javax.management.MBeanServerFactory.getClassLoaderRepository(MBeanServer server) Default Loader Repository The object's class should have a public constructor. The call returns a reference to the newly created object. The newly created object is not registered in the MBean server.
  Specified by:
    `instantiate` in interface `MBeanServer`
  Parameters:
    `className` - The class name of the object to be instantiated.
    `params` - An array containing the parameters of the constructor to be invoked.
    `signatures` - An array containing the signature of the constructor to be invoked
  Returns:
    The newly instantiated object.
  Throws:
    `ReflectionException` - Wraps a java.lang.ClassNotFoundException or the java.lang.Exception that occurred when trying to reflectInvoke the object's constructor.
    `MBeanException` - Wraps a java.lang.IllegalArgumentException: The className passed in parameter is null.

### instantiate

    public java.lang.Object instantiate(java.lang.String className,
                                        ObjectName loaderName,
                                        java.lang.Object[] params,
                                        java.lang.String[] signatures)
                                 throws ReflectionException,
                                        MBeanException,
                                        InstanceNotFoundException

  Description copied from interface: `MBeanServer`
  Instantiates an object. The class loader to be used is identified by its object name. If the object name of the loader is null, the ClassLoader that loaded the MBean server will be used. The object's class should have a public constructor. The call returns a reference to the newly created object. The newly created object is not registered in the MBean server.
  Specified by:
    `instantiate` in interface `MBeanServer`
  Following copied from interface: `javax.management.MBeanServer`
  Parameters:
    `className` - The class name of the object to be instantiated.
    `params` - An array containing the parameters of the constructor to be invoked.
    `signature` - An array containing the signature of the constructor to be invoked.
    `loaderName` - The object name of the class loader to be used.
  Returns:
    The newly instantiated object.
  Throws:
    `ReflectionException` - Wraps a `java.lang.ClassNotFoundException` or the `java.lang.Exception` that occurred when trying to invoke the object's constructor.
    `MBeanException` - The constructor of the object has thrown an exception
    `InstanceNotFoundException` - The specified class loader is not registered in the MBean server.
    `RuntimeOperationsException` - Wraps a `java.lang.IllegalArgumentException`: The className passed in parameter is null.

### createMBean

    public ObjectInstance createMBean(java.lang.String className,
                                      ObjectName objectName)
                               throws ReflectionException,
                                      InstanceAlreadyExistsException,
                                      MBeanRegistrationException,
                                      MBeanException,
                                      NotCompliantMBeanException

  Description copied from interface: `MBeanServer`
  Instantiates and registers an MBean in the MBean server. The MBean server will use the javax.management.MBeanServerFactory.getClassLoaderRepository(MBeanServer server) Default Loader Repository to load the class of the MBean. An object name is associated to the MBean. If the object name given is null, the MBean can automatically provide its own name by implementing the `MBeanRegistration` interface. The call returns an `ObjectInstance` object representing the newly created MBean.
  Specified by:
    `createMBean` in interface `MBeanServer`
  Following copied from interface: `javax.management.MBeanServer`
  Parameters:
    `className` - The class name of the MBean to be instantiated.
    `name` - The object name of the MBean. May be null.
  Returns:
    An `ObjectInstance`, containing the `ObjectName` and the Java class name of the newly instantiated MBean.
  Throws:
    `ReflectionException` - Wraps a `java.lang.ClassNotFoundException` or a ``java.lang.Exception`` that occurred when trying to invoke the MBean's constructor.
    `InstanceAlreadyExistsException` - The MBean is already under the control of the MBean server.
    `MBeanRegistrationException` - The `preRegister` (`MBeanRegistration` interface) method of the MBean has thrown an exception. The MBean will not be registered.
    `MBeanException` - The constructor of the MBean has thrown an exception
    `NotCompliantMBeanException` - This class is not a JMX compliant MBean
    `RuntimeOperationsException` - Wraps a `java.lang.IllegalArgumentException`: The className passed in parameter is null, the `ObjectName` passed in parameter contains a pattern or no `ObjectName` is specified for the MBean.

### createMBean

    public ObjectInstance createMBean(java.lang.String className,
                                      ObjectName objectName,
                                      ObjectName loaderName)
                               throws ReflectionException,
                                      InstanceAlreadyExistsException,
                                      MBeanRegistrationException,
                                      MBeanException,
                                      NotCompliantMBeanException,
                                      InstanceNotFoundException

  Description copied from interface: `MBeanServer`
  Instantiates and registers an MBean in the MBean server. The class loader to be used is identified by its object name. An object name is associated to the MBean. If the object name of the loader is null, the ClassLoader that loaded the MBean server will be used. If the MBean's object name given is null, the MBean can automatically provide its own name by implementing the `MBeanRegistration` interface. The call returns an `ObjectInstance` object representing the newly created MBean.
  Specified by:
    `createMBean` in interface `MBeanServer`
  Following copied from interface: `javax.management.MBeanServer`
  Parameters:
    `className` - The class name of the MBean to be instantiated.
    `name` - The object name of the MBean. May be null.
    `loaderName` - The object name of the class loader to be used.
  Returns:
    An `ObjectInstance`, containing the `ObjectName` and the Java class name of the newly instantiated MBean.
  Throws:
    `ReflectionException` - Wraps a `java.lang.ClassNotFoundException` or a `java.lang.Exception` that occurred when trying to invoke the MBean's constructor.
    `InstanceAlreadyExistsException` - The MBean is already under the control of the MBean server.
    `MBeanRegistrationException` - The `preRegister` (`MBeanRegistration` interface) method of the MBean has thrown an exception. The MBean will not be registered.
    `MBeanException` - The constructor of the MBean has thrown an exception
    `NotCompliantMBeanException` - This class is not a JMX compliant MBean
    `InstanceNotFoundException` - The specified class loader is not registered in the MBean server.
    `RuntimeOperationsException` - Wraps a `java.lang.IllegalArgumentException`: The className passed in parameter is null, the `ObjectName` passed in parameter contains a pattern or no `ObjectName` is specified for the MBean.

### createMBean

    public ObjectInstance createMBean(java.lang.String className,
                                      ObjectName objectName,
                                      java.lang.Object[] params,
                                      java.lang.String[] signatures)
                               throws ReflectionException,
                                      InstanceAlreadyExistsException,
                                      MBeanRegistrationException,
                                      MBeanException,
                                      NotCompliantMBeanException

  Description copied from interface: `MBeanServer`
  Instantiates and registers an MBean in the MBean server. The MBean server will use the javax.management.MBeanServerFactory.getClassLoaderRepository(MBeanServer server) Default Loader Repository to load the class of the MBean. An object name is associated to the MBean. If the object name given is null, the MBean can automatically provide its own name by implementing the `MBeanRegistration` interface. The call returns an `ObjectInstance` object representing the newly created MBean.
  Specified by:
    `createMBean` in interface `MBeanServer`
  Following copied from interface: `javax.management.MBeanServer`
  Parameters:
    `className` - The class name of the MBean to be instantiated.
    `name` - The object name of the MBean. May be null.
    `params` - An array containing the parameters of the constructor to be invoked.
    `signature` - An array containing the signature of the constructor to be invoked.
  Returns:
    An `ObjectInstance`, containing the `ObjectName` and the Java class name of the newly instantiated MBean.
  Throws:
    `ReflectionException` - Wraps a `java.lang.ClassNotFoundException` or a `java.lang.Exception` that occurred when trying to invoke the MBean's constructor.
    `InstanceAlreadyExistsException` - The MBean is already under the control of the MBean server.
    `MBeanRegistrationException` - The `preRegister` (`MBeanRegistration` interface) method of the MBean has thrown an exception. The MBean will not be registered.
    `MBeanException` - The constructor of the MBean has thrown an exception
    `RuntimeOperationsException` - Wraps a `java.lang.IllegalArgumentException`: The className passed in parameter is null, the `ObjectName` passed in parameter contains a pattern or no `ObjectName` is specified for the MBean.

### createMBean

    public ObjectInstance createMBean(java.lang.String className,
                                      ObjectName objectName,
                                      ObjectName loaderName,
                                      java.lang.Object[] params,
                                      java.lang.String[] signatures)
                               throws ReflectionException,
                                      InstanceAlreadyExistsException,
                                      MBeanRegistrationException,
                                      MBeanException,
                                      NotCompliantMBeanException,
                                      InstanceNotFoundException

  Description copied from interface: `MBeanServer`
  Instantiates and registers an MBean in the MBean server. The class loader to be used is identified by its object name. An object name is associated to the MBean. If the object name of the loader is not specified, the ClassLoader that loaded the MBean server will be used. If the MBean object name given is null, the MBean can automatically provide its own name by implementing the `MBeanRegistration` interface. The call returns an `ObjectInstance` object representing the newly created MBean.
  Specified by:
    `createMBean` in interface `MBeanServer`
  Following copied from interface: `javax.management.MBeanServer`
  Parameters:
    `className` - The class name of the MBean to be instantiated.
    `name` - The object name of the MBean. May be null.
    `params` - An array containing the parameters of the constructor to be invoked.
    `signature` - An array containing the signature of the constructor to be invoked.
    `loaderName` - The object name of the class loader to be used.
  Returns:
    An `ObjectInstance`, containing the `ObjectName` and the Java class name of the newly instantiated MBean.
  Throws:
    `ReflectionException` - Wraps a `java.lang.ClassNotFoundException` or a `java.lang.Exception` that occurred when trying to invoke the MBean's constructor.
    `InstanceAlreadyExistsException` - The MBean is already under the control of the MBean server.
    `MBeanRegistrationException` - The `preRegister` (`MBeanRegistration` interface) method of the MBean has thrown an exception. The MBean will not be registered.
    `MBeanException` - The constructor of the MBean has thrown an exception
    `InstanceNotFoundException` - The specified class loader is not registered in the MBean server.
    `RuntimeOperationsException` - Wraps a `java.lang.IllegalArgumentException`: The className passed in parameter is null, the `ObjectName` passed in parameter contains a pattern or no `ObjectName` is specified for the MBean.

### registerMBean

    public ObjectInstance registerMBean(java.lang.Object obj,
                                        ObjectName objectName)
                                 throws InstanceAlreadyExistsException,
                                        MBeanRegistrationException,
                                        NotCompliantMBeanException

  Description copied from interface: `MBeanServer`
  Registers a pre-existing object as an MBean with the MBean server. If the object name given is null, the MBean may automatically provide its own name by implementing the `MBeanRegistration` interface. The call returns an `ObjectInstance` object representing the registered MBean.
  Specified by:
    `registerMBean` in interface `MBeanServer`
  Following copied from interface: `javax.management.MBeanServer`
  Parameters:
    `object` - The MBean to be registered as an MBean.
    `name` - The object name of the MBean. May be null.
  Returns:
    The `ObjectInstance` for the MBean that has been registered.
  Throws:
    `InstanceAlreadyExistsException` - The MBean is already under the control of the MBean server.
    `MBeanRegistrationException` - The `preRegister` (`MBeanRegistration` interface) method of the MBean has thrown an exception. The MBean will not be registered.
    `NotCompliantMBeanException` - This object is not a JMX compliant MBean
    `RuntimeOperationsException` - Wraps a `java.lang.IllegalArgumentException`: The object passed in parameter is null or no object name is specified.

### unregisterMBean

    public void unregisterMBean(ObjectName objectName)
                         throws InstanceNotFoundException,
                                MBeanRegistrationException

  Description copied from interface: `MBeanServer`
  De-registers an MBean from the MBean server. The MBean is identified by its object name. Once the method has been invoked, the MBean may no longer be accessed by its object name.
  Specified by:
    `unregisterMBean` in interface `MBeanServer`
  Following copied from interface: `javax.management.MBeanServer`
  Parameters:
    `name` - The object name of the MBean to be de-registered.
  Throws:
    `InstanceNotFoundException` - The MBean specified is not registered in the MBean server.
    `MBeanRegistrationException` - The preDeregister ((`MBeanRegistration` interface) method of the MBean has thrown an exception.
    `RuntimeOperationsException` - Wraps a `java.lang.IllegalArgumentException`: The object name in parameter is null or the MBean you are when trying to de-register is the `MBeanServerDelegate` MBean.

### getObjectInstance

    public ObjectInstance getObjectInstance(ObjectName objectName)
                                     throws InstanceNotFoundException

  Description copied from interface: `MBeanServer`
  Gets the `ObjectInstance` for a given MBean registered with the MBean server.
  Specified by:
    `getObjectInstance` in interface `MBeanServer`
  Following copied from interface: `javax.management.MBeanServer`
  Parameters:
    `name` - The object name of the MBean.
  Returns:
    The `ObjectInstance` associated to the MBean specified by name.
  Throws:
    `InstanceNotFoundException` - The MBean specified is not registered in the MBean server.

### queryMBeans

    public java.util.Set queryMBeans(ObjectName objectName,
                                     QueryExp query)

  Description copied from interface: `MBeanServer`
  Gets MBeans controlled by the MBean server. This method allows any of the following to be obtained: All MBeans, a set of MBeans specified by pattern matching on the `ObjectName` and/or a Query expression, a specific MBean. When the object name is null or no domain and key properties are specified, all objects are to be selected (and filtered if a query is specified). It returns the set of `ObjectInstance` objects (containing the `ObjectName` and the Java Class name) for the selected MBeans.
  Specified by:
    `queryMBeans` in interface `MBeanServer`
  Following copied from interface: `javax.management.MBeanServer`
  Parameters:
    `name` - The object name pattern identifying the MBeans to be retrieved. If null or no domain and key properties are specified, all the MBeans registered will be retrieved.
    `query` - The query expression to be applied for selecting MBeans. If null no query expression will be applied for selecting MBeans.
  Returns:
    A set containing the `ObjectInstance` objects for the selected MBeans. If no MBean satisfies the query an empty list is returned.

### queryNames

    public java.util.Set queryNames(ObjectName objectName,
                                    QueryExp query)

  Description copied from interface: `MBeanServer`
  Gets the names of MBeans controlled by the MBean server. This method enables any of the following to be obtained: The names of all MBeans, the names of a set of MBeans specified by pattern matching on the `ObjectName` and/or a Query expression, a specific MBean name (equivalent to testing whether an MBean is registered). When the object name is null or no domain and key properties are specified, all objects are selected (and filtered if a query is specified). It returns the set of ObjectNames for the MBeans selected.
  Specified by:
    `queryNames` in interface `MBeanServer`
  Following copied from interface: `javax.management.MBeanServer`
  Parameters:
    `name` - The object name pattern identifying the MBeans to be retrieved. If null or no domain and key properties are specified, all the MBeans registered will be retrieved.
    `query` - The query expression to be applied for selecting MBeans. If null no query expression will be applied for selecting MBeans.
  Returns:
    A set containing the ObjectNames for the MBeans selected. If no MBean satisfies the query, an empty list is returned.

### isRegistered

    public boolean isRegistered(ObjectName objectName)

  Description copied from interface: `MBeanServer`
  Checks whether an MBean, identified by its object name, is already registered with the MBean server.
  Specified by:
    `isRegistered` in interface `MBeanServer`
  Following copied from interface: `javax.management.MBeanServer`
  Parameters:
    `name` - The object name of the MBean to be checked.
  Returns:
    True if the MBean is already registered in the MBean server, false otherwise.
  Throws:
    `RuntimeOperationsException` - Wraps a `java.lang.IllegalArgumentException`: The object name in parameter is null.

### getMBeanCount

    public java.lang.Integer getMBeanCount()

  Description copied from interface: `MBeanServer`
  Returns the number of MBeans registered in the MBean server.
  Specified by:
    `getMBeanCount` in interface `MBeanServer`
  Following copied from interface: `javax.management.MBeanServerConnection`
  Returns:
    the number of MBeans registered.
  Throws:
    `java.io.IOException` - A communication problem occurred when talking to the MBean server.

### getAttribute

    public java.lang.Object getAttribute(ObjectName objectName,
                                         java.lang.String attribute)
                                  throws MBeanException,
                                         AttributeNotFoundException,
                                         InstanceNotFoundException,
                                         ReflectionException

  Description copied from interface: `MBeanServer`
  Gets the value of a specific attribute of a named MBean. The MBean is identified by its object name.
  Specified by:
    `getAttribute` in interface `MBeanServer`
  Following copied from interface: `javax.management.MBeanServer`
  Parameters:
    `name` - The object name of the MBean from which the attribute is to be retrieved.
    `attribute` - A String specifying the name of the attribute to be retrieved.
  Returns:
    The value of the retrieved attribute.
  Throws:
    `AttributeNotFoundException` - The attribute specified is not accessible in the MBean.
    `MBeanException` - Wraps an exception thrown by the MBean's getter.
    `InstanceNotFoundException` - The MBean specified is not registered in the MBean server.
    `ReflectionException` - Wraps a `java.lang.Exception` thrown when trying to invoke the setter.
    `RuntimeOperationsException` - Wraps a `java.lang.IllegalArgumentException`: The object name in parameter is null or the attribute in parameter is null.

### getAttributes

    public AttributeList getAttributes(ObjectName objectName,
                                       java.lang.String[] attributes)
                                throws InstanceNotFoundException,
                                       ReflectionException

  Description copied from interface: `MBeanServer`
  Enables the values of several attributes of a named MBean. The MBean is identified by its object name.
  Specified by:
    `getAttributes` in interface `MBeanServer`
  Following copied from interface: `javax.management.MBeanServer`
  Parameters:
    `name` - The object name of the MBean from which the attributes are retrieved.
    `attributes` - A list of the attributes to be retrieved.
  Returns:
    The list of the retrieved attributes.
  Throws:
    `InstanceNotFoundException` - The MBean specified is not registered in the MBean server.
    `ReflectionException` - An exception occurred when trying to invoke the getAttributes method of a Dynamic MBean.
    `RuntimeOperationsException` - Wrap a `java.lang.IllegalArgumentException`: The object name in parameter is null or attributes in parameter is null.

### setAttribute

    public void setAttribute(ObjectName objectName,
                             Attribute attribute)
                      throws InstanceNotFoundException,
                             AttributeNotFoundException,
                             InvalidAttributeValueException,
                             MBeanException,
                             ReflectionException

  Description copied from interface: `MBeanServer`
  Sets the value of a specific attribute of a named MBean. The MBean is identified by its object name.
  Specified by:
    `setAttribute` in interface `MBeanServer`
  Following copied from interface: `javax.management.MBeanServer`
  Parameters:
    `name` - The name of the MBean within which the attribute is to be set.
    `attribute` - The identification of the attribute to be set and the value it is to be set to.
  Throws:
    `InstanceNotFoundException` - The MBean specified is not registered in the MBean server.
    `AttributeNotFoundException` - The attribute specified is not accessible in the MBean.
    `InvalidAttributeValueException` - The value specified for the attribute is not valid.
    `MBeanException` - Wraps an exception thrown by the MBean's setter.
    `ReflectionException` - Wraps a `java.lang.Exception` thrown when trying to invoke the setter.
    `RuntimeOperationsException` - Wraps a `java.lang.IllegalArgumentException`: The object name in parameter is null or the attribute in parameter is null.

### setAttributes

    public AttributeList setAttributes(ObjectName objectName,
                                       AttributeList attributes)
                                throws InstanceNotFoundException,
                                       ReflectionException

  Description copied from interface: `MBeanServer`
  Sets the values of several attributes of a named MBean. The MBean is identified by its object name.
  Specified by:
    `setAttributes` in interface `MBeanServer`
  Following copied from interface: `javax.management.MBeanServer`
  Parameters:
    `name` - The object name of the MBean within which the attributes are to be set.
    `attributes` - A list of attributes: The identification of the attributes to be set and the values they are to be set to.
  Returns:
    The list of attributes that were set, with their new values.
  Throws:
    `InstanceNotFoundException` - The MBean specified is not registered in the MBean server.
    `ReflectionException` - An exception occurred when trying to invoke the getAttributes method of a Dynamic MBean.
    `RuntimeOperationsException` - Wraps a `java.lang.IllegalArgumentException`: The object name in parameter is null or attributes in parameter is null.

### invoke

    public java.lang.Object invoke(ObjectName objectName,
                                   java.lang.String operationName,
                                   java.lang.Object[] params,
                                   java.lang.String[] signatures)
                            throws InstanceNotFoundException,
                                   MBeanException,
                                   ReflectionException

  Description copied from interface: `MBeanServer`
  Invokes an operation on an MBean.
  Specified by:
    `invoke` in interface `MBeanServer`
  Following copied from interface: `javax.management.MBeanServer`
  Parameters:
    `name` - The object name of the MBean on which the method is to be invoked.
    `operationName` - The name of the operation to be invoked.
    `params` - An array containing the parameters to be set when the operation is invoked
    `signature` - An array containing the signature of the operation. The class objects will be loaded using the same class loader as the one used for loading the MBean on which the operation was invoked.
  Returns:
    The object returned by the operation, which represents the result ofinvoking the operation on the MBean specified.
  Throws:
    `InstanceNotFoundException` - The MBean specified is not registered in the MBean server.
    `MBeanException` - Wraps an exception thrown by the MBean's invoked method.
    `ReflectionException` - Wraps a `java.lang.Exception` thrown while trying to invoke the method.

### getDefaultDomain

    public java.lang.String getDefaultDomain()

  Description copied from interface: `MBeanServer`
  Returns the default domain used for naming the MBean. The default domain name is used as the domain part in the ObjectName of MBeans if no domain is specified by the user.
  Specified by:
    `getDefaultDomain` in interface `MBeanServer`
  Following copied from interface: `javax.management.MBeanServerConnection`
  Returns:
    the default domain.
  Throws:
    `java.io.IOException` - A communication problem occurred when talking to the MBean server.

### addNotificationListener

    public void addNotificationListener(ObjectName objectName,
                                        NotificationListener listener,
                                        NotificationFilter filter,
                                        java.lang.Object handback)
                                 throws InstanceNotFoundException

  Description copied from interface: `MBeanServer`
  Enables to add a listener to a registered MBean.
  Specified by:
    `addNotificationListener` in interface `MBeanServer`
  Following copied from interface: `javax.management.MBeanServer`
  Parameters:
    `name` - The name of the MBean on which the listener should be added.
    `listener` - The listener object which will handle the notifications emitted by the registered MBean.
    `filter` - The filter object. If filter is null, no filtering will be performed before handling notifications.
    `handback` - The context to be sent to the listener when a notification is emitted.
  Throws:
    `InstanceNotFoundException` - The MBean name provided does not match any of the registered MBeans.

### addNotificationListener

    public void addNotificationListener(ObjectName objectName,
                                        ObjectName listenerName,
                                        NotificationFilter filter,
                                        java.lang.Object handback)
                                 throws InstanceNotFoundException

  Description copied from interface: `MBeanServer`
  Enables to add a listener to a registered MBean.
  Specified by:
    `addNotificationListener` in interface `MBeanServer`
  Following copied from interface: `javax.management.MBeanServer`
  Parameters:
    `name` - The name of the MBean on which the listener should be added.
    `listener` - The object name of the listener which will handle the notifications emitted by the registered MBean.
    `filter` - The filter object. If filter is null, no filtering will be performed before handling notifications.
    `handback` - The context to be sent to the listener when a notification is emitted.
  Throws:
    `InstanceNotFoundException` - The MBean name of the notification listener or of the notification broadcaster does not match any of the registered MBeans.

### removeNotificationListener

    public void removeNotificationListener(ObjectName objectName,
                                           NotificationListener listener)
                                    throws InstanceNotFoundException,
                                           ListenerNotFoundException

  Description copied from interface: `MBeanServer`
  Enables to remove a listener from a registered MBean.
  Specified by:
    `removeNotificationListener` in interface `MBeanServer`
  Following copied from interface: `javax.management.MBeanServer`
  Parameters:
    `name` - The name of the MBean on which the listener should be removed.
    `listener` - The listener object which will handle the notifications emitted by the registered MBean. This method will remove all the information related to this listener.
  Throws:
    `InstanceNotFoundException` - The MBean name provided does not match any of the registered MBeans.
    `ListenerNotFoundException` - The listener is not registered in the MBean.

### removeNotificationListener

    public void removeNotificationListener(ObjectName objectName,
                                           ObjectName listenerName)
                                    throws InstanceNotFoundException,
                                           ListenerNotFoundException

  Description copied from interface: `MBeanServer`
  Enables to remove a listener from a registered MBean.
  Specified by:
    `removeNotificationListener` in interface `MBeanServer`
  Following copied from interface: `javax.management.MBeanServer`
  Parameters:
    `name` - The name of the MBean on which the listener should be removed.
    `listener` - The object name of the listener which will handle the notifications emitted by the registered MBean. This method will remove all the information related to this listener.
  Throws:
    `InstanceNotFoundException` - The MBean name provided does not match any of the registered MBeans.
    `ListenerNotFoundException` - The listener is not registered in the MBean.

### getMBeanInfo

    public MBeanInfo getMBeanInfo(ObjectName objectName)
                           throws InstanceNotFoundException,
                                  IntrospectionException,
                                  ReflectionException

  Description copied from interface: `MBeanServer`
  This method discovers the attributes and operations that an MBean exposes for management.
  Specified by:
    `getMBeanInfo` in interface `MBeanServer`
  Following copied from interface: `javax.management.MBeanServer`
  Parameters:
    `name` - The name of the MBean to analyze
  Returns:
    An instance of `MBeanInfo` allowing the retrieval of all attributes and operations of this MBean.
  Throws:
    `IntrospectionException` - An exception occurs during introspection.
    `InstanceNotFoundException` - The MBean specified is not found.
    `ReflectionException` - An exception occurred when trying to invoke the getMBeanInfo of a Dynamic MBean.

### isInstanceOf

    public boolean isInstanceOf(ObjectName objectName,
                                java.lang.String className)
                         throws InstanceNotFoundException

  Description copied from interface: `MBeanServer`
  Returns true if the MBean specified is an instance of the specified class, false otherwise.
  Specified by:
    `isInstanceOf` in interface `MBeanServer`
  Following copied from interface: `javax.management.MBeanServer`
  Parameters:
    `name` - The `ObjectName` of the MBean.
    `className` - The name of the class.
  Returns:
    true if the MBean specified is an instance of the specified class, false otherwise.
  Throws:
    `InstanceNotFoundException` - The MBean specified is not registered in the MBean server.

### getClassLoaderFor

    public java.lang.ClassLoader getClassLoaderFor(ObjectName objectName)
                                            throws InstanceNotFoundException

  Return the `ClassLoader` that was used for loading the class of the named MBean.

  Specified by:
    `getClassLoaderFor` in interface `MBeanServer`
  Parameters:
    `objectName` - The ObjectName of the MBean.
  Returns:
    The ClassLoader used for that MBean. If l is the MBean's actual ClassLoader, and r is the returned value, then either:
    - r is identical to l; or
    - the result of r`.loadClass(s)` is the same as l`.loadClass(s)` for any string s.
    What this means is that the ClassLoader may be wrapped in another ClassLoader for security or other reasons.
  Throws:
    `InstanceNotFoundException` - if the named MBean is not found.
  Since:
    JMX 1.2

### getClassLoader

    public java.lang.ClassLoader getClassLoader(ObjectName loaderName)
                                         throws InstanceNotFoundException

  Return the named `ClassLoader`.

  Specified by:
    `getClassLoader` in interface `MBeanServer`
  Parameters:
    `loaderName` - The ObjectName of the ClassLoader. May be null, in which case the MBean server's own ClassLoader is returned.
  Returns:
    The named ClassLoader. If l is the actual ClassLoader with that name, and r is the returned value, then either:
    - r is identical to l; or
    - the result of r`.loadClass(s)` is the same as l`.loadClass(s)` for any string s.
    What this means is that the ClassLoader may be wrapped in another ClassLoader for security or other reasons.
  Throws:
    `InstanceNotFoundException` - if the named ClassLoader is not found.
  Since:
    JMX 1.2

### getClassLoaderRepository

    public ClassLoaderRepository getClassLoaderRepository()

  Description copied from interface: `MBeanServer`

  Return the ClassLoaderRepository for this MBeanServer.

  Specified by:
    `getClassLoaderRepository` in interface `MBeanServer`
  Following copied from interface: `javax.management.MBeanServer`
  Returns:
    The ClassLoaderRepository for this MBeanServer.

### getDomains

    public java.lang.String[] getDomains()

  Description copied from interface: `MBeanServer`

  Returns the list of domains in which any MBean is currently registered. A string is in the returned array if and only if there is at least one MBean registered with an ObjectName whose `getDomain()` is equal to that string. The order of strings within the returned array is not defined.

  Specified by:
    `getDomains` in interface `MBeanServer`
  Following copied from interface: `javax.management.MBeanServer`
  Returns:
    the list of domains.

### removeNotificationListener

    public void removeNotificationListener(ObjectName objectName,
                                           ObjectName listenerName,
                                           NotificationFilter filter,
                                           java.lang.Object handback)
                                    throws InstanceNotFoundException,
                                           ListenerNotFoundException

  Removes a listener from a registered MBean.

  The MBean must have a listener that exactly matches the given `listener`, `filter`, and `handback` parameters. If there is more than one such listener, only one is removed.

  The `filter` and `handback` parameters may be null if and only if they are null in a listener to be removed.

  Specified by:
    `removeNotificationListener` in interface `MBeanServer`
  Parameters:
    `objectName` - The name of the MBean on which the listener should be removed.
    `listenerName` - A listener that was previously added to this MBean.
    `filter` - The filter that was specified when the listener was added.
    `handback` - The handback that was specified when the listener was added.
  Throws:
    `InstanceNotFoundException` - The MBean name provided does not match any of the registered MBeans.
    `ListenerNotFoundException` - The listener is not registered in the MBean, or it is not registered with the given filter and handback.
  Since:
    JMX 1.2
  See Also:
    `addNotificationListener(ObjectName, ObjectName, NotificationFilter, Object)`

### removeNotificationListener

    public void removeNotificationListener(ObjectName objectName,
                                           NotificationListener listener,
                                           NotificationFilter filter,
                                           java.lang.Object handback)
                                    throws InstanceNotFoundException,
                                           ListenerNotFoundException

  Removes a listener from a registered MBean.

  The MBean must have a listener that exactly matches the given `listener`, `filter`, and `handback` parameters. If there is more than one such listener, only one is removed.

  The `filter` and `handback` parameters may be null if and only if they are null in a listener to be removed.

  Specified by:
    `removeNotificationListener` in interface `MBeanServer`
  Parameters:
    `objectName` - The name of the MBean on which the listener should be removed.
    `listener` - A listener that was previously added to this MBean.
    `filter` - The filter that was specified when the listener was added.
    `handback` - The handback that was specified when the listener was added.
  Throws:
    `InstanceNotFoundException` - The MBean name provided does not match any of the registered MBeans.
    `ListenerNotFoundException` - The listener is not registered in the MBean, or it is not registered with the given filter and handback.
  Since:
    JMX 1.2
  See Also:
    `addNotificationListener(ObjectName, NotificationListener, NotificationFilter, Object)`

### registerInterceptor

    public void registerInterceptor(MBeanServerInterceptorListener interceptor,
                                    MBeanServerNotificationFilter filter,
                                    java.lang.Object handback)

  This function is JFoxMX private extension
  Specified by:
    `registerInterceptor` in interface `ExtendedMBeanServer`
  Parameters:
    `interceptor` -

### unregisterInterceptor

    public void unregisterInterceptor(MBeanServerInterceptorListener interceptor)
                               throws ListenerNotFoundException

  Specified by:
    `unregisterInterceptor` in interface `ExtendedMBeanServer`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD